<template>
  <div>
    <div
      id="modal_proveedor_editar"
      class="modal fade"
      tabindex="-1"
      aria-hidden="true"
      data-bs-backdrop="static"
      data-bs-keyboard="false"
    >
      <div class="modal-dialog mw-750px">
        <div
          id="modal_proveedor_editar_formulario"
          class="modal-content rounded"
        >
          <div class="modal-header">
            <h3 class="modal-title">
              Editar un proveedor
            </h3>

            <div
              id="modal_proveedor_editar_btn_cerrar"
              class="btn btn-icon btn-sm btn-active-light-primary ms-2"
              data-bs-dismiss="modal"
              aria-label="Close"
              @click="onCerrarModal()"
            >
              <i class="bi bi-x-lg" />
            </div>
          </div>

          <div class="modal-body scroll-y px-10 px-lg-15 pt-0 pb-0">
            <div class="row">
              <div class="col-xxl-12 col-form-label">
                <label class="required fw-bolder fs-6">Nombre</label>
              </div>
              <div class="col-xxl-12">
                <input
                  ref="modalProveedorEditarNombre"
                  v-model="mFormulario.nombre"
                  type="text"
                  class="form-control"
                  placeholder=""
                  maxlength="50"
                >
              </div>
            </div>

            <div class="row">
              <div class="col-xl-6">
                <div class="row">
                  <div class="col-xxl-12 col-form-label">
                    <label class="required fw-bolder fs-6">Nit</label>
                  </div>
                  <div class="col-xxl-12">
                    <input
                      ref="modalProveedorEditarNit"
                      v-model="mFormulario.nit"
                      type="text"
                      class="form-control"
                      placeholder=""
                      maxlength="20"
                    >
                  </div>
                </div>
              </div>
              <div class="col-xl-6">
                <div class="row">
                  <div class="col-xxl-12 col-form-label">
                    <label class="required fw-bolder fs-6">Teléfono</label>
                  </div>
                  <div class="col-xxl-12">
                    <input
                      ref="modalProveedorEditarTelefono"
                      v-model="mFormulario.telefono"
                      type="tel"
                      class="form-control"
                      placeholder=""
                      maxlength="15"
                    >
                  </div>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-xxl-12 col-form-label">
                <label class="required fw-bolder fs-6">Dirección</label>
              </div>
              <div class="col-xxl-12">
                <input
                  ref="modalProveedorEditarDireccion"
                  v-model="mFormulario.direccion"
                  type="text"
                  class="form-control"
                  placeholder=""
                  maxlength="100"
                >
              </div>
            </div>

            <div class="row">
              <div class="col-xxl-12 col-form-label">
                <label class="required fw-bolder fs-6">Logo
                  <i
                    class="fas fa-exclamation-circle ms-2 fs-7"
                    data-bs-toggle="tooltip"
                    title="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                    data-bs-original-title="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                    aria-label="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                  />
                </label>
              </div>
              <div class="col-xxl-12">
                <div
                  id="modal_proveedor_editar_ktinputimagen"
                  class="image-input  image-input-empty"
                  :style="'background-image: url('+mFormulario.urlImagen+')'"
                >
                  <div class="image-input-wrapper w-125px h-125px" />
                  <label
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="change"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Cambiar imagen"
                  >
                    <i class="bi bi-pencil-fill fs-7" />
                    <input
                      type="file"
                      name="avatar"
                      accept=".png, .jpg, .jpeg"
                    >
                    <input
                      type="hidden"
                      name="avatar_remove"
                    >
                  </label>
                  <span
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="cancel"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Cancelar imagen"
                  >
                    <i class="bi bi-x fs-2" />
                  </span>
                  <span
                    id="modal_proveedor_editar_ktinputimagen_eliminar"
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="remove"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Eliminar imagen"
                  >
                    <i class="bi bi-x fs-2" />
                  </span>
                </div>
              </div>
            </div>

            <div class="row mb-2">
              <div class="col-xxl-12">
                <label class="required fw-bolder fs-6">Geolocalización</label>
              </div>
              <div class="col-xxl-12">
                <GoogleMap
                  api-key="AIzaSyA2XeZf5gGUwUTKl9y-hq2GsMdTlCJCgds"
                  style="width: 100%; height: 500px"
                  :center="{lat: mFormulario.latitud, lng: mFormulario.longitud}"
                  :zoom="14"
                >
                  <Marker
                    :options="{ position: {lat: mFormulario.latitud, lng: mFormulario.longitud}, draggable: true, clickable: true }"
                    @dragend="onGeolocalizacionActualizar($event)"
                  />
                </GoogleMap>
              </div>
            </div>
          </div>

          <div class="modal-footer px-10 py-5">
            <button
              type="button"
              class="btn btn-secondary"
              data-bs-dismiss="modal"
              @click="onCerrarModal()"
            >
              Cancelar
            </button>
            <button
              id="modal_proveedor_editar_btn_guardar"
              type="button"
              class="btn btn-primary"
              @click="onProveedorModificar()"
            >
              <span class="indicator-label">Guardar</span>
              <span class="indicator-progress">
                Espere por favor... <span class="spinner-border spinner-border-sm align-middle ms-2" />
              </span>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import InputImagen from "@/core/util/InputImagen";
import BloqueoUI from "@/core/util/BloqueoUI";
import { GoogleMap, Marker } from "vue3-google-map";
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import Alerta from "@/core/util/Alerta";

export default {
  name: 'ModalProveedorEditar',
  components: {
    GoogleMap, Marker
  },
  props: {
    proveedor: { type: Object, required: true, default() {
        return {
          nombre: {type: String, required: true},
          nit: {type: String, required: true},
          telefono: {type: String, required: true},
          direccion: {type: String, required: true},
          urlImagen: {type: String, required: true},
          urlThumbnail: {type: String, required: true},
          latitud: {type: Number, required: true},
          longitud: {type: Number, required: true},
        }
      }
    }
  },
  emits: ['onProveedorListar'],

  data() {
    return {
      componentes: {
        inputImagen: null,
        bloqueoUI: null,
      },
      mFormulario: {
        nombre: '',
        nit: '',
        telefono: '',
        direccion: '',
        imagen: null,
        urlImagen: '',
        urlThumbnail: '',
        latitud: -17.783602,
        longitud: -63.182327,
      }
    };
  },

  watch: {
    proveedor: function(value) {
      this.mFormulario.nombre = value.nombre;
      this.mFormulario.nit = value.nit;
      this.mFormulario.telefono = value.telefono;
      this.mFormulario.direccion = value.direccion;
      this.mFormulario.latitud = value.latitud;
      this.mFormulario.longitud = value.longitud;
      this.mFormulario.urlImagen = value.urlImagen;
      this.mFormulario.urlThumbnail = value.urlThumbnail;
    }
  },

  mounted() {
    this.componentes.inputImagen = new InputImagen('#modal_proveedor_editar_ktinputimagen');
    this.componentes.bloqueoUI = new BloqueoUI('#modal_proveedor_editar_formulario', '#modal_proveedor_editar_btn_guardar');
  },
  methods: {
    onProveedorModificar() {
      this.mFormulario.imagen = this.componentes.inputImagen.imagen;

      this.componentes.bloqueoUI.iniciarBloqueoFormulario();
      Servicio.postMultiPart(Ruta.rutaPanelProveedorModificar(this.proveedor.id), this.mFormulario).then( (data) => {
        Toast.mostrarExito(data.mensaje);
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        this.$emit('onProveedorListar');
        this.cerrarModal();
      }).catch((error) => {
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Alerta.alertaError(error);
      });
    },

    onCerrarModal() {
      this.mFormulario = {nombre: '', nit: '', telefono: '', direccion: '',
        imagen: null, latitud: -17.783602, longitud: -63.182327
      };
      this.componentes.inputImagen.limpiar();
    },

    onGeolocalizacionActualizar(event) {
      this.mFormulario.latitud = event.latLng.lat();
      this.mFormulario.longitud = event.latLng.lng();
    },

    cerrarModal() {
      document.querySelector('#modal_proveedor_editar_btn_cerrar').click();
    }
  }
}
</script>